# -*- coding: utf-8 -*-

import os
from Handlers import BaseHandler
from Utils import Utils
import zipfile
import hashlib
#-------------------------------------------------------------------------------
#
#-------------------------------------------------------------------------------
class Firmup(BaseHandler.BaseHandler):
	#=======================================================
	# 
	#=======================================================
	def __init__(self):
		self.name = 'Firmup'
		self.upload_path = "/tmp"
		self.firmup_file = "%s/firmware.img" % self.upload_path
	#=======================================================
	# 
	#=======================================================
	def Get(self, request):
	
		status = 200
		return self.readVersion(), status

	#=======================================================
	# 
	#=======================================================
	def Put(self, request):
		
		status = 400
		if os.path.exists(self.firmup_file):
			status = self.firmUpdate()
		return status

	#=======================================================
	# 
	#=======================================================
	def Post(self, request):

		status = 400
		result = {}
		file_name = request.get_header('X-File')
		if file_name:
			result, status = self.saveUpdatefile(file_name)
		
		return result, status

	#=======================================================
	# 
	#=======================================================
	def readVersion(self):
		version = open('/etc/version', 'r').read().strip('\n')
		return {'version': version}

	#=======================================================
	# 
	#=======================================================
	def saveUpdatefile(self, file_name):

		status = 200
		try:
			if os.path.exists(self.firmup_file):
				os.remove(self.firmup_file)
			os.rename(file_name, self.firmup_file)
			file_size = os.path.getsize(self.firmup_file)
			fd = open(self.firmup_file, 'rb')
			sha1sum = hashlib.sha1(fd.read()).hexdigest()

			result = {'sha1sum':sha1sum,  'filesize':file_size}
		except Exception as e:
			self.log('save update file failed. %s' % e)
			status = 400

		return result, status

	#=======================================================
	# 
	#=======================================================
	def firmUpdate(self):
		status = 200
		res = self.call(['firmup', self.firmup_file])
		if res:
			status = 415

		os.remove(self.firmup_file)
		return status

